// Copyright 2019, University of Freiburg,
// Chair of Algorithms and Data Structures.
// Authors: Patrick Brosi <brosi@informatik.uni-freiburg.de>

#include <iostream>
#include "osmfixer/index/StatIdx.h"
#include "osmfixer/server/StatServer.h"
#include "util/http/Server.h"
#include "util/log/Log.h"

using osmfixer::StatServer;
using osmfixer::StatIdx;

// _____________________________________________________________________________
int main(int argc, char** argv) {
  // disable output buffering for standard output
  setbuf(stdout, NULL);

  // initialize randomness
  srand(time(NULL) + rand());  // NOLINT

  int port = 9090;

  if (argc < 2) {
    LOG(ERROR) << "Missing path to stations file.";
    exit(1);
  }

  StatIdx idx;
  idx.readFromFile(argv[1]);

  LOG(INFO) << "Starting server...";
  StatServer serv(&idx);

  LOG(INFO) << "Listening on port " << port;
  util::http::HttpServer(port, &serv).run();
}
